﻿using System;
using System.Windows.Controls;
using System.Globalization;

namespace TestProject
{
    /// <summary>
    /// 날짜 검증 규칙
    /// </summary>
    public class DateValidationRule : ValidationRule
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 검증하기 - Validate(value, cultureInfo)

        /// <summary>
        /// 검증하기
        /// </summary>
        /// <param name="value">값</param>
        /// <param name="cultureInfo">문화 정보</param>
        /// <returns>검증 결과</returns>
        public override ValidationResult Validate(object value, CultureInfo cultureInfo)
        {
            DateTime date;

            try
            {
                date = DateTime.Parse(value.ToString());
            }
            catch(FormatException)
            {
                return new ValidationResult(false, "값이 적절한 날짜가 아닙니다.");
            }

            if(DateTime.Now.Date > date)
            {
                return new ValidationResult(false, "날짜는 오늘 이후 날짜이어야 합니다.");
            }
            else
            {
                return ValidationResult.ValidResult;
            }
        }

        #endregion
    }
}