﻿using System;
using System.Windows.Controls;
using System.Globalization;

namespace TestProject
{
    /// <summary>
    /// 가격 검증 규칙
    /// </summary>
    public class PriceValidationRule : ValidationRule
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 검증하기 - Validate(value, cultureInfo)

        /// <summary>
        /// 검증하기
        /// </summary>
        /// <param name="value">값</param>
        /// <param name="cultureInfo">문화 정보</param>
        /// <returns>검증 결과</returns>
        public override ValidationResult Validate(object value, CultureInfo cultureInfo)
        {
            try
            {
                double price = Convert.ToDouble(value);

                if(price < 0)
                {
                    return new ValidationResult(false, "가격은 양수이어야 합니다.");
                }
                else
                {
                    return ValidationResult.ValidResult;
                }
            }
            catch(Exception)
            {
                return new ValidationResult(false, "가격은 숫자이어야 합니다.");
            }
        }

        #endregion
    }
}